#ifndef _port_h

#define BUS_DATA_MASK		0x00FF
#define BUS_DATA_LATCH		LATB
#define BUS_DATA_TRIS 		TRISB
#define BUS_DATA_PIN		PORTB

#define bus_data_in()      {BUS_DATA_TRIS |= BUS_DATA_MASK;}
#define bus_data_out()     {BUS_DATA_TRIS &= ~BUS_DATA_MASK;}

#define BUS_ADDR_MASK		0x000F
#define BUS_ADDR_LATCH		LATD
#define BUS_ADDR_TRIS 		TRISD

#define bus_addr(addr)      {BUS_ADDR_LATCH = (BUS_ADDR_LATCH & ~BUS_ADDR_MASK) | (addr & BUS_ADDR_MASK);}

#define BUS_RD_MASK		    0x0100
#define BUS_RD_LATCH		LATB
#define BUS_RD_TRIS		    TRISB

#define BUS_WR_MASK		    0x0200
#define BUS_WR_LATCH		LATB
#define BUS_WR_TRIS		    TRISB

#define bus_wr_hi()     {BUS_WR_LATCH |= BUS_WR_MASK;}
#define bus_wr_lo()     {BUS_WR_LATCH &= ~BUS_WR_MASK;}

#define bus_rd_hi()     {BUS_RD_LATCH |= BUS_RD_MASK;}
#define bus_rd_lo()     {BUS_RD_LATCH &= ~BUS_RD_MASK;}

void port_init(void);
void port_write(uint16_t addr, uint16_t data);
uint8_t port_read(uint16_t addr);

#endif //_port_h
