#define GPIO1_MASK		    0x0400
#define GPIO1_LATCH		    LATB
#define GPIO1_TRIS		    TRISB
#define GPIO1_PIN			PORTB

#define GPIO2_MASK		    0x0800
#define GPIO2_LATCH		    LATB
#define GPIO2_TRIS		    TRISB
#define GPIO2_PIN			PORTB

#define GPIO3_MASK		    0x1000
#define GPIO3_LATCH		    LATB
#define GPIO3_TRIS		    TRISB
#define GPIO3_PIN			PORTB

#define GPIO4_MASK		    0x0040
#define GPIO4_LATCH		    LATF
#define GPIO4_TRIS		    TRISF
#define GPIO4_PIN			PORTF

#define gpio_out(gpio) {GPIO##gpio##_TRIS &= ~GPIO##gpio##_MASK;}
#define gpio_in(gpio)  {GPIO##gpio##_TRIS |= GPIO##gpio##_MASK;}
#define gpio_get(gpio) (GPIO##gpio##_PIN & GPIO##gpio##_MASK)
#define gpio_hi(gpio)  {GPIO##gpio##_LATCH |= GPIO##gpio##_MASK;}
#define gpio_lo(gpio)  {GPIO##gpio##_LATCH &= ~GPIO##gpio##_MASK;}


#define LCD_CS      1
#define LCD_COMMAND 2
#define LCD_DATA    0

#define G_START 0x0800
#define T_START 0x0000

#define CMD_MWRITE 0x42


void lcd_write_cmd(uint8_t cmd);
void lcd_write_data(uint8_t cmd);
void lcd_init(void);
void lcd_clear(void);
void lcd_set_cursor(uint16_t addr);
void lcd_gotoxy(int x, int y);
void lcd_putc(unsigned char c);
